#! /bin/bash

#SBATCH -J MPISORT_MYSAM_4_JOBS
#SBATCH -N 2                       	# Ask 2 nodes
#SBATCH -n 4                       	# Total number of cores
#SBATCH -c 1			   	# use 1 core per mpi job
#SBATCH --tasks-per-node=2         	# Ask 2 cores per node
#SBATCH --mem-per-cpu=${MEM}	   	# See Memory ressources
#SBATCH -t 01:00:00
#SBATCH -o STDOUT_FILE.%j.o
#SBATCH -e STDERR_FILE.%j.e

type mpiSORT

if [[ ! $? -eq 0 ]]
then
    echo "ERROR: mpiSORT not found in your PATH"
    exit 1
fi

output_dir=${HOME}/mpiSORTExample

if [[ ! -d ${output_dir} ]]
then
    mkdir -p ${output_dir}
    echo "INFO: the directory ${output_dir} has been created to store the results generated by mpiSORTExample"
fi

cd ${SLURM_SUBMIT_DIR}

mpirun -n 4 mpiSORT data/HCC1187C_70K_READS.sam ${output_dir} -p -q 0 2> ${output_dir}/mpiSORT.log

echo "INFO: mpiSORT.log is available in ${output_dir}"

