#! /bin/bash

type mpiSORT

if [[ ! $? -eq 0 ]]
then
    echo "ERROR: mpiSORT not found in your PATH"
    exit 1
fi

output_dir=${HOME}/mpiSORTExample

if [[ ! -d ${output_dir} ]]
then
    mkdir -p ${output_dir}
    echo "INFO: the directory ${output_dir} has been created to store the results generated by mpiSORTExample"
fi

mpirun -n 4 mpiSORT data/HCC1187C_70K_READS.sam ${output_dir} -p -q 0 2> ${output_dir}/mpiSORT.log

echo "INFO: mpiSORT.log is available in ${output_dir}"

